#include "TXXXMakeCal.h"
#include "Riostream.h"
#include "TH1.h"
#include "TXXXParam.h"

#include "TXXXEventUnp.h"
#include "TXXXEventCal.h"

//***********************************************************
TXXXMakeCal::TXXXMakeCal() : TGo4EventProcessor("Proc")
{
  cout << "**** TXXXMakeCal: Create instance " << endl;
}
//***********************************************************
TXXXMakeCal::~TXXXMakeCal()
{
  cout << "**** TXXXMakeCal: Delete instance " << endl;
}
//***********************************************************
// this one is used in standard factory
TXXXMakeCal::TXXXMakeCal(const char* name) : TGo4EventProcessor(name)
{
  cout << "**** TXXXMakeCal: Create instance " << name << endl;

  //// init user analysis objects:

// Create of parameters and histograms (check if restored from auto save file):
  fPar1  = (TXXXParam *) MakeParameter("Cal/Par1","TXXXParam"); // class TXXXParam
  fHis1  = (TH1I *) MakeTH1('I',"Cal/CalHis1","Channel 1",1000,1,5000,"Channels");
}
//-----------------------------------------------------------
// event function
Bool_t TXXXMakeCal::BuildEvent(TGo4EventElement * output)
{
  Int_t items,i;

  TXXXEventUnp * input  = (TXXXEventUnp *) GetInputEvent();
  TXXXEventCal * target = (TXXXEventCal *) output;
  items = sizeof(target->fCal1)/sizeof(target->fCal1[0]);
  for(i = 0; i < items; i++)
    target->fCal1[i] = fPar1->fOffset+fPar1->fFactor * input->fUnp1[i];
  items = sizeof(target->fCal2)/sizeof(target->fCal2[0]);
  for(i = 0; i < items; i++) 
    target->fCal2[i] = fPar1->fOffset+fPar1->fFactor * input->fUnp2[i];
  FillHistograms(target); // fill histograms from event
  target->SetValid(kTRUE);
  return kTRUE;
}

//-----------------------------------------------------------
// histogramming function
Bool_t TXXXMakeCal::FillHistograms(TXXXEventCal * event)
{
  fHis1->Fill(event->fCal1[0]);                        
  return kTRUE;
}
//----------------------------END OF GO4 SOURCE FILE ---------------------
