#include "TXXXMakeUnp.h"
#include "Riostream.h"
#include "TH1.h"

#include "TXXXEventUnp.h"

//***********************************************************
TXXXMakeUnp::TXXXMakeUnp() : TGo4EventProcessor("Proc")
{
  cout << "**** TXXXMakeUnp: Create instance " << endl;
}
//***********************************************************
TXXXMakeUnp::~TXXXMakeUnp()
{
  cout << "**** TXXXMakeUnp: Delete instance " << endl;
}
//***********************************************************
// this one is used in standard factory
TXXXMakeUnp::TXXXMakeUnp(const char* name) : TGo4EventProcessor(name)
{
  cout << "**** TXXXMakeUnp: Create instance " << name << endl;
// Create of parameters and histograms (check if restored from auto save file):
  fHis1  = (TH1I *) MakeTH1('I',"Unp/UnpHis1","Channel 1",1000,1,5000,"Channels");
}
//-----------------------------------------------------------
// event function
Bool_t TXXXMakeUnp::BuildEvent(TGo4EventElement * output)
{
  Int_t lwords,i;
  Int_t *pdata;
  TGo4MbsSubEvent * rawsub;

  TGo4MbsEvent * raw    = (TGo4MbsEvent* ) GetInputEvent();
  TXXXEventUnp * target = (TXXXEventUnp *) output;
  memset(target->fUnp1, 0, sizeof(target->fUnp1));
  memset(target->fUnp2, 0, sizeof(target->fUnp2));
  // Copy data from input event into local arrays
  raw->ResetIterator();  // prepare loop over sub-events
  while((rawsub = raw->NextSubEvent()) != 0) // loop over subevents
    {
      pdata  = rawsub->GetDataField(); // pointer to first data longword
      lwords = rawsub->GetIntLen();    // number of longwords
      if(lwords > 8) lwords=8;         // take only first 8 lwords
      if(rawsub->GetSubcrate() == 1)
	for(i = 0; i < lwords; i++) target->fUnp1[i] = (Float_t)*pdata++;
      if(rawsub->GetSubcrate() == 2)
	for(i = 0; i < lwords; i++) target->fUnp2[i] = (Float_t)*pdata++;
    } // while subevents

  target->SetValid(kTRUE);
  FillHistograms(target); // fill histograms from output event

  return kTRUE;
}

//-----------------------------------------------------------
// histogramming function
Bool_t TXXXMakeUnp::FillHistograms(TXXXEventUnp * event)
{
  fHis1->Fill(event->fUnp1[0]);                        
  return kTRUE;
}
//----------------------------END OF GO4 SOURCE FILE ---------------------
