#include "TXXXParam.h"
#include "Riostream.h"

//***********************************************************
TXXXParam::TXXXParam() : TGo4Parameter("Parameter")
{
  fFill=kTRUE;
  fOutput=kFALSE;
  fOffset=100;
  fFactor=1;
}
//***********************************************************
TXXXParam::TXXXParam(const char* name) : TGo4Parameter(name)
{
  fFill=kTRUE;
  fOutput=kFALSE;
  fOffset=100;
  fFactor=1;
}
//***********************************************************
TXXXParam::~TXXXParam()
{
}
//***********************************************************

//-----------------------------------------------------------
Int_t TXXXParam::PrintParameter()
{
  cout << "Parameter " << GetName() << ":";
  cout << " fill="     << fFill;
  cout << " output="   << fOutput;
  cout << " offset="   << fOffset;
  cout << " factor="   << fFactor << endl;
  return 0;
}
//-----------------------------------------------------------
Int_t TXXXParam::PrintParameter(Text_t * n, Int_t)
{
  PrintParameter();
  return 0;
}
//-----------------------------------------------------------
Bool_t TXXXParam::UpdateFrom(TGo4Parameter *pp)
{
  if(pp->InheritsFrom("TXXXParam"))
  {
    TXXXParam * from;
    from = (TXXXParam *) pp;
    cout << "**** TXXXParam " << GetName() << " updated from auto save file" << endl;
    fFill   = from->fFill;
    fOutput = from->fOutput;
    fOffset = from->fOffset;
    fFactor = from->fFactor;
    PrintParameter();
  }
     else
     cout << "Wrong parameter object: " << pp->ClassName() << endl;
  return kTRUE;
}

//----------------------------END OF GO4 SOURCE FILE ---------------------
